Package org.eclipse.jdt.core.dom

# Class MethodInvocation

java.lang.Object
org.eclipse.jdt.core.dom.ASTNode
org.eclipse.jdt.core.dom.Expression
org.eclipse.jdt.core.dom.MethodInvocation

public class MethodInvocation extends Expression
Method invocation expression AST node type.

     MethodInvocation:
         [ Expression . ]
             [ < Type { , Type } > ]
             Identifier ( [ Expression { , Expression } ] )

Since:
  2.0
Restriction:
  This class is not intended to be instantiated by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ChildListPropertyDescriptor`
`ARGUMENTS_PROPERTY`
The "arguments" structural property of this node type (element type: `Expression`).
`static final ChildPropertyDescriptor`
`EXPRESSION_PROPERTY`
The "expression" structural property of this node type (child type: `Expression`).
`static final ChildPropertyDescriptor`
`NAME_PROPERTY`
The "name" structural property of this node type (child type: `SimpleName`).
`static final ChildListPropertyDescriptor`
`TYPE_ARGUMENTS_PROPERTY`
The "typeArguments" structural property of this node type (element type: `Type`) (added in JLS3 API).

### Fields inherited from class org.eclipse.jdt.core.dom.ASTNode

`ANNOTATION_TYPE_DECLARATION, ANNOTATION_TYPE_MEMBER_DECLARATION, ANONYMOUS_CLASS_DECLARATION, ARRAY_ACCESS, ARRAY_CREATION, ARRAY_INITIALIZER, ARRAY_TYPE, ASSERT_STATEMENT, ASSIGNMENT, BLOCK, BLOCK_COMMENT, BOOLEAN_LITERAL, BREAK_STATEMENT, CASE_DEFAULT_EXPRESSION, CAST_EXPRESSION, CATCH_CLAUSE, CHARACTER_LITERAL, CLASS_INSTANCE_CREATION, COMPILATION_UNIT, CONDITIONAL_EXPRESSION, CONSTRUCTOR_INVOCATION, CONTINUE_STATEMENT, CREATION_REFERENCE, DIMENSION, DO_STATEMENT, EMPTY_STATEMENT, ENHANCED_FOR_STATEMENT, ENUM_CONSTANT_DECLARATION, ENUM_DECLARATION, EXPORTS_DIRECTIVE, EXPRESSION_METHOD_REFERENCE, EXPRESSION_STATEMENT, FIELD_ACCESS, FIELD_DECLARATION, FOR_STATEMENT, GUARDED_PATTERN, IF_STATEMENT, IMPORT_DECLARATION, INFIX_EXPRESSION, INITIALIZER, INSTANCEOF_EXPRESSION, INTERSECTION_TYPE, JAVADOC, JAVADOC_REGION, JAVADOC_TEXT_ELEMENT, LABELED_STATEMENT, LAMBDA_EXPRESSION, LINE_COMMENT, MALFORMED, MARKER_ANNOTATION, MEMBER_REF, MEMBER_VALUE_PAIR, METHOD_DECLARATION, METHOD_INVOCATION, METHOD_REF, METHOD_REF_PARAMETER, MODIFIER, MODULE_DECLARATION, MODULE_MODIFIER, MODULE_QUALIFIED_NAME, NAME_QUALIFIED_TYPE, NORMAL_ANNOTATION, NULL_LITERAL, NULL_PATTERN, NUMBER_LITERAL, OPENS_DIRECTIVE, ORIGINAL, PACKAGE_DECLARATION, PARAMETERIZED_TYPE, PARENTHESIZED_EXPRESSION, PATTERN_INSTANCEOF_EXPRESSION, POSTFIX_EXPRESSION, PREFIX_EXPRESSION, PRIMITIVE_TYPE, PROTECT, PROVIDES_DIRECTIVE, QUALIFIED_NAME, QUALIFIED_TYPE, RECORD_DECLARATION, RECORD_PATTERN, RECOVERED, REQUIRES_DIRECTIVE, RETURN_STATEMENT, SIMPLE_NAME, SIMPLE_TYPE, SINGLE_MEMBER_ANNOTATION, SINGLE_VARIABLE_DECLARATION, STRING_LITERAL, SUPER_CONSTRUCTOR_INVOCATION, SUPER_FIELD_ACCESS, SUPER_METHOD_INVOCATION, SUPER_METHOD_REFERENCE, SWITCH_CASE, SWITCH_EXPRESSION, SWITCH_STATEMENT, SYNCHRONIZED_STATEMENT, TAG_ELEMENT, TAG_PROPERTY, TEXT_BLOCK, TEXT_ELEMENT, THIS_EXPRESSION, THROW_STATEMENT, TRY_STATEMENT, TYPE_DECLARATION, TYPE_DECLARATION_STATEMENT, TYPE_LITERAL, TYPE_METHOD_REFERENCE, TYPE_PARAMETER, TYPE_PATTERN, UNION_TYPE, USES_DIRECTIVE, VARIABLE_DECLARATION_EXPRESSION, VARIABLE_DECLARATION_FRAGMENT, VARIABLE_DECLARATION_STATEMENT, WHILE_STATEMENT, WILDCARD_TYPE, YIELD_STATEMENT`

## Method Summary

Modifier and Type
Method
Description
`List`
`arguments()`
Returns the live ordered list of argument expressions in this method invocation expression.
`Expression`
`getExpression()`
Returns the expression of this method invocation expression, or `null` if there is none.
`SimpleName`
`getName()`
Returns the name of the method invoked in this expression.
`boolean`
`isResolvedTypeInferredFromExpectedType()`
Returns `true` if the resolved return type has been inferred from the assignment context (JLS3 15.12.2.8), `false` otherwise.
`static List`
`propertyDescriptors(int apiLevel)`
Returns a list of structural property descriptors for this node type.
`IMethodBinding`
`resolveMethodBinding()`
Resolves and returns the binding for the method invoked by this expression.
`void`
`setExpression(Expression expression)`
Sets or clears the expression of this method invocation expression.
`void`
`setName(SimpleName name)`
Sets the name of the method invoked in this expression to the given name.
`List`
`typeArguments()`
Returns the live ordered list of type arguments of this method invocation (added in JLS3 API).

### Methods inherited from class org.eclipse.jdt.core.dom.Expression

`resolveBoxing, resolveConstantExpressionValue, resolveTypeBinding, resolveUnboxing`

### Methods inherited from class org.eclipse.jdt.core.dom.ASTNode

`accept, copySubtree, copySubtrees, delete, equals, getAST, getFlags, getLength, getLocationInParent, getNodeType, getParent, getProperty, getRoot, getStartPosition, getStructuralProperty, hashCode, nodeClassForType, properties, setFlags, setProperty, setSourceRange, setStructuralProperty, structuralPropertiesForType, subtreeBytes, subtreeMatch, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### EXPRESSION_PROPERTY

public static final ChildPropertyDescriptor EXPRESSION_PROPERTY
The "expression" structural property of this node type (child type: `Expression`).

Since:
  3.0

### TYPE_ARGUMENTS_PROPERTY

public static final ChildListPropertyDescriptor TYPE_ARGUMENTS_PROPERTY
The "typeArguments" structural property of this node type (element type: `Type`) (added in JLS3 API).

Since:
  3.1

### NAME_PROPERTY

public static final ChildPropertyDescriptor NAME_PROPERTY
The "name" structural property of this node type (child type: `SimpleName`).

Since:
  3.0

### ARGUMENTS_PROPERTY

public static final ChildListPropertyDescriptor ARGUMENTS_PROPERTY
The "arguments" structural property of this node type (element type: `Expression`).

Since:
  3.0

## Method Details

### propertyDescriptors

public static List propertyDescriptors(int apiLevel)
Returns a list of structural property descriptors for this node type. Clients must not modify the result.

Parameters:
  `apiLevel` - the API level; one of the `AST.JLS*` constants
Returns:
  a list of property descriptors (element type: `StructuralPropertyDescriptor`)
Since:
  3.0

### getExpression

public Expression getExpression()
Returns the expression of this method invocation expression, or `null` if there is none.

Returns:
  the expression node, or `null` if there is none

### isResolvedTypeInferredFromExpectedType

public boolean isResolvedTypeInferredFromExpectedType()
Returns `true` if the resolved return type has been inferred from the assignment context (JLS3 15.12.2.8), `false` otherwise.

This information is available only when bindings are requested when the AST is being built

.

Returns:
  `true` if the resolved return type has been inferred from the assignment context (JLS3 15.12.2.8), `false` otherwise
Since:
  3.3

### setExpression

public void setExpression(Expression expression)
Sets or clears the expression of this method invocation expression.

Parameters:
  `expression` - the expression node, or `null` if there is none
Throws:
  `IllegalArgumentException` - if:
  - the node belongs to a different AST
  - the node already has a parent
  - a cycle in would be created

### typeArguments

public List typeArguments()
Returns the live ordered list of type arguments of this method invocation (added in JLS3 API).

Returns:
  the live list of type arguments (element type: `Type`)
Throws:
  `UnsupportedOperationException` - if this operation is used in a JLS2 AST
Since:
  3.1

### getName

public SimpleName getName()
Returns the name of the method invoked in this expression.

Returns:
  the method name node

### setName

public void setName(SimpleName name)
Sets the name of the method invoked in this expression to the given name.

Parameters:
  `name` - the new method name
Throws:
  `IllegalArgumentException` - if:
  - the node belongs to a different AST
  - the node already has a parent

### arguments

public List arguments()
Returns the live ordered list of argument expressions in this method invocation expression.

Returns:
  the live list of argument expressions (element type: `Expression`)

### resolveMethodBinding

public IMethodBinding resolveMethodBinding()
Resolves and returns the binding for the method invoked by this expression.

Note that bindings are generally unavailable unless requested when the AST is being built.

Returns:
  the method binding, or `null` if the binding cannot be resolved
Since:
  2.1